var _this = this,
    _jsxFileName = "C:\\github\\os\\react-most-wanted\\packages\\material-ui-shell\\src\\components\\MenuHeader\\MenuHeader.js";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React, { useContext } from 'react';
import Avatar from '@material-ui/core/Avatar';
import ChevronLeft from '@material-ui/icons/ChevronLeft';
import ChevronRight from '@material-ui/icons/ChevronRight';
import ChromeReaderMode from '@material-ui/icons/ChromeReaderMode';
import IconButton from '@material-ui/core/IconButton';
import List from '@material-ui/core/List';
import ListItem from '@material-ui/core/ListItem';
import ListItemAvatar from '@material-ui/core/ListItemAvatar';
import ListItemSecondaryAction from '@material-ui/core/ListItemSecondaryAction';
import ListItemText from '@material-ui/core/ListItemText';
import Paper from '@material-ui/core/Paper';
import PersonIcon from '@material-ui/icons/Person';
import ConfigContext from 'base-shell/lib/providers/Config/Context';
import MenuContext from '../../providers/Menu/Context';
import ThemeContext from '../../providers/Theme/Context';
import { makeStyles, useTheme } from '@material-ui/core/styles';
import clsx from 'clsx';
import ArroWDropDownIcon from '@material-ui/icons/ArrowDropDown';
import ArroWDropUpIcon from '@material-ui/icons/ArrowDropUp';
import Brightness4Icon from '@material-ui/icons/Brightness4';
import BrightnessHighIcon from '@material-ui/icons/BrightnessHigh';
var useStyles = makeStyles(function (theme) {
  return {
    paper: {
      backgroundColor: theme.palette.primary.dark,
      margin: 0,
      padding: 0
    },
    listItem: {
      color: theme.palette.primary.contrastText,
      cursor: 'pointer'
    },
    icon: {
      color: theme.palette.primary.contrastText,
      cursor: 'pointer'
    },
    toolbar: _extends({
      display: 'flex',
      alignItems: 'center',
      justifyContent: 'flex-end',
      padding: theme.spacing(0, 2)
    }, theme.mixins.toolbar)
  };
});

var MenuHeader = function MenuHeader() {
  var theme = useTheme();

  var _useContext = useContext(ConfigContext),
      appConfig = _useContext.appConfig;

  var _useContext2 = useContext(ThemeContext),
      type = _useContext2.type,
      setType = _useContext2.setType;

  var _ref = appConfig || {},
      menu = _ref.menu;

  var authData = appConfig.auth.getData();
  var classes = useStyles();

  var _useContext3 = useContext(MenuContext),
      isDesktop = _useContext3.isDesktop,
      isDesktopOpen = _useContext3.isDesktopOpen,
      setDesktopOpen = _useContext3.setDesktopOpen,
      isMini = _useContext3.isMini,
      setMini = _useContext3.setMini,
      isAuthMenuOpen = _useContext3.isAuthMenuOpen,
      setAuthMenuOpen = _useContext3.setAuthMenuOpen,
      useMiniMode = _useContext3.useMiniMode;

  return /*#__PURE__*/React.createElement(Paper, {
    square: true,
    className: classes.paper,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 67,
      columnNumber: 5
    }
  }, isMini && authData.isAuthorised && /*#__PURE__*/React.createElement("div", {
    className: classes.toolbar,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 69,
      columnNumber: 9
    }
  }), /*#__PURE__*/React.createElement(List, {
    className: clsx(!authData.isAuthorised && classes.toolbar),
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 71,
      columnNumber: 7
    }
  }, /*#__PURE__*/React.createElement(ListItem, {
    className: classes.listItem,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 72,
      columnNumber: 9
    }
  }, authData.isAuthorised && /*#__PURE__*/React.createElement(React.Fragment, {
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 74,
      columnNumber: 13
    }
  }, authData.photoURL && /*#__PURE__*/React.createElement(ListItemAvatar, {
    onClick: function onClick() {
      setAuthMenuOpen(!isAuthMenuOpen);
    },
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 76,
      columnNumber: 17
    }
  }, /*#__PURE__*/React.createElement(Avatar, {
    src: authData.photoURL,
    alt: "user",
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 81,
      columnNumber: 19
    }
  })), !authData.photoURL && /*#__PURE__*/React.createElement(ListItemAvatar, {
    onClick: function onClick() {
      setAuthMenuOpen(!isAuthMenuOpen);
    },
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 85,
      columnNumber: 17
    }
  }, /*#__PURE__*/React.createElement(Avatar, {
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 90,
      columnNumber: 19
    }
  }, authData.displayName ? authData.displayName[0].toUpperCase() : /*#__PURE__*/React.createElement(PersonIcon, {
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 94,
      columnNumber: 25
    }
  })))), !isMini && /*#__PURE__*/React.createElement(ListItemSecondaryAction, {
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 102,
      columnNumber: 13
    }
  }, /*#__PURE__*/React.createElement(IconButton, {
    onClick: function onClick() {
      setType(type === 'light' ? 'dark' : 'light');
    },
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 103,
      columnNumber: 15
    }
  }, type === 'light' && /*#__PURE__*/React.createElement(Brightness4Icon, {
    classes: {
      root: classes.icon
    },
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 109,
      columnNumber: 19
    }
  }), type === 'dark' && /*#__PURE__*/React.createElement(BrightnessHighIcon, {
    classes: {
      root: classes.icon
    },
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 112,
      columnNumber: 19
    }
  })), isDesktop && /*#__PURE__*/React.createElement(React.Fragment, null, useMiniMode && /*#__PURE__*/React.createElement(IconButton, {
    onClick: function onClick() {
      setMini(true);
      setDesktopOpen(false);
    },
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 118,
      columnNumber: 21
    }
  }, /*#__PURE__*/React.createElement(ChromeReaderMode, {
    classes: {
      root: classes.icon
    },
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 124,
      columnNumber: 23
    }
  })), /*#__PURE__*/React.createElement(IconButton, {
    color: "inherit",
    onClick: function onClick() {
      setDesktopOpen(false);
    },
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 128,
      columnNumber: 19
    }
  }, theme.direction === 'rtl' && /*#__PURE__*/React.createElement(ChevronRight, {
    classes: {
      root: classes.icon
    },
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 135,
      columnNumber: 23
    }
  }), theme.direction !== 'rtl' && /*#__PURE__*/React.createElement(ChevronLeft, {
    classes: {
      root: classes.icon
    },
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 138,
      columnNumber: 23
    }
  })), "  "))), authData.isAuthorised && /*#__PURE__*/React.createElement(ListItem, {
    onClick: function onClick() {
      setAuthMenuOpen(!isAuthMenuOpen);
    },
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 146,
      columnNumber: 11
    }
  }, !isDesktopOpen && isDesktop && authData.photoURL && /*#__PURE__*/React.createElement(ListItemAvatar, {
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 152,
      columnNumber: 15
    }
  }, /*#__PURE__*/React.createElement(Avatar, {
    src: authData.photoURL,
    alt: "person",
    style: {
      marginLeft: -7,
      marginTop: 3
    },
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 153,
      columnNumber: 17
    }
  })), !isMini && /*#__PURE__*/React.createElement(ListItemText, {
    classes: {
      primary: classes.listItem,
      secondary: classes.listItem
    },
    style: {
      marginLeft: !isDesktopOpen && isDesktop && authData.photoURL ? 7 : undefined
    },
    primary: authData.displayName,
    secondary: authData.email,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 162,
      columnNumber: 15
    }
  }), isDesktopOpen && /*#__PURE__*/React.createElement(ListItemSecondaryAction, {
    onClick: function onClick() {
      setAuthMenuOpen(!isAuthMenuOpen);
    },
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 178,
      columnNumber: 15
    }
  }, /*#__PURE__*/React.createElement(IconButton, {
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 183,
      columnNumber: 17
    }
  }, isAuthMenuOpen && /*#__PURE__*/React.createElement(ArroWDropUpIcon, {
    classes: {
      root: classes.icon
    },
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 185,
      columnNumber: 21
    }
  }), !isAuthMenuOpen && /*#__PURE__*/React.createElement(ArroWDropDownIcon, {
    classes: {
      root: classes.icon
    },
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 188,
      columnNumber: 21
    }
  }))))));
};

export default MenuHeader;