var _this = this,
    _jsxFileName = "C:\\github\\os\\react-most-wanted\\packages\\material-ui-shell\\src\\containers\\Menu\\Menu.js";

import React, { useContext } from 'react';
import { useHistory, useRouteMatch } from 'react-router-dom';
import ConfigContext from 'base-shell/lib/providers/Config/Context';
import MenuContext from '../../providers/Menu/Context';
import { useIntl } from 'react-intl';
import ResponsiveMenu from '../ResponsiveMenu/ResponsiveMenu';
import SelectableMenuList from '../../containers/SelectableMenuList';
import LocaleContext from 'base-shell/lib/providers/Locale/Context';
import Scrollbar from '../../components/Scrollbar/Scrollbar';
import ThemeContext from 'material-ui-shell/lib/providers/Theme/Context';

var Menu = function Menu() {
  var intl = useIntl();
  var history = useHistory();
  var match = useRouteMatch();
  var menuContext = useContext(MenuContext);
  var isDesktopOpen = menuContext.isDesktopOpen,
      isMini = menuContext.isMini,
      setDesktopOpen = menuContext.setDesktopOpen,
      setMobileOpen = menuContext.setMobileOpen,
      useMiniMode = menuContext.useMiniMode;

  var _useContext = useContext(ConfigContext),
      appConfig = _useContext.appConfig;

  var _useContext2 = useContext(LocaleContext),
      setLocale = _useContext2.setLocale,
      _useContext2$locale = _useContext2.locale,
      locale = _useContext2$locale === void 0 ? 'en' : _useContext2$locale;

  var _ref = appConfig || {},
      menu = _ref.menu;

  var _ref2 = menu || {},
      MenuHeader = _ref2.MenuHeader,
      getMenuItems = _ref2.getMenuItems;

  var themeContext = useContext(ThemeContext);
  var menuItems = getMenuItems({
    intl,
    locale,
    updateLocale: setLocale,
    menuContext,
    themeContext,
    appConfig
  }).filter(function (item) {
    return item.visible !== false;
  });
  var index = match ? match.path : '/';

  var handleChange = function handleChange(event, index) {
    if (index !== undefined) {
      setMobileOpen(false);
    }

    if (index !== undefined && index !== Object(index)) {
      history.push(index);
    }
  };

  return /*#__PURE__*/React.createElement(ResponsiveMenu, {
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 52,
      columnNumber: 5
    }
  }, MenuHeader && /*#__PURE__*/React.createElement(MenuHeader, {
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 53,
      columnNumber: 22
    }
  }), /*#__PURE__*/React.createElement("div", {
    style: {
      display: 'flex',
      flexDirection: 'column',
      height: '100%'
    },
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 54,
      columnNumber: 7
    }
  }, /*#__PURE__*/React.createElement(Scrollbar, {
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 61,
      columnNumber: 9
    }
  }, /*#__PURE__*/React.createElement(SelectableMenuList, {
    items: menuItems,
    onIndexChange: handleChange,
    index: index,
    key: useMiniMode,
    useMinified: isMini && !isDesktopOpen,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 62,
      columnNumber: 11
    }
  }))));
};

export default Menu;