"use strict";

exports.__esModule = true;
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _Avatar = _interopRequireDefault(require("@material-ui/core/Avatar"));

var _ChevronLeft = _interopRequireDefault(require("@material-ui/icons/ChevronLeft"));

var _ChevronRight = _interopRequireDefault(require("@material-ui/icons/ChevronRight"));

var _ChromeReaderMode = _interopRequireDefault(require("@material-ui/icons/ChromeReaderMode"));

var _IconButton = _interopRequireDefault(require("@material-ui/core/IconButton"));

var _List = _interopRequireDefault(require("@material-ui/core/List"));

var _ListItem = _interopRequireDefault(require("@material-ui/core/ListItem"));

var _ListItemAvatar = _interopRequireDefault(require("@material-ui/core/ListItemAvatar"));

var _ListItemSecondaryAction = _interopRequireDefault(require("@material-ui/core/ListItemSecondaryAction"));

var _ListItemText = _interopRequireDefault(require("@material-ui/core/ListItemText"));

var _Paper = _interopRequireDefault(require("@material-ui/core/Paper"));

var _Person = _interopRequireDefault(require("@material-ui/icons/Person"));

var _Context = _interopRequireDefault(require("base-shell/lib/providers/Config/Context"));

var _Context2 = _interopRequireDefault(require("../../providers/Menu/Context"));

var _Context3 = _interopRequireDefault(require("../../providers/Theme/Context"));

var _styles = require("@material-ui/core/styles");

var _clsx = _interopRequireDefault(require("clsx"));

var _ArrowDropDown = _interopRequireDefault(require("@material-ui/icons/ArrowDropDown"));

var _ArrowDropUp = _interopRequireDefault(require("@material-ui/icons/ArrowDropUp"));

var _Brightness = _interopRequireDefault(require("@material-ui/icons/Brightness4"));

var _BrightnessHigh = _interopRequireDefault(require("@material-ui/icons/BrightnessHigh"));

var _this = void 0,
    _jsxFileName = "C:\\github\\os\\react-most-wanted\\packages\\material-ui-shell\\src\\components\\MenuHeader\\MenuHeader.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var useStyles = (0, _styles.makeStyles)(function (theme) {
  return {
    paper: {
      backgroundColor: theme.palette.primary.dark,
      margin: 0,
      padding: 0
    },
    listItem: {
      color: theme.palette.primary.contrastText,
      cursor: 'pointer'
    },
    icon: {
      color: theme.palette.primary.contrastText,
      cursor: 'pointer'
    },
    toolbar: _extends({
      display: 'flex',
      alignItems: 'center',
      justifyContent: 'flex-end',
      padding: theme.spacing(0, 2)
    }, theme.mixins.toolbar)
  };
});

var MenuHeader = function MenuHeader() {
  var theme = (0, _styles.useTheme)();

  var _useContext = (0, _react.useContext)(_Context.default),
      appConfig = _useContext.appConfig;

  var _useContext2 = (0, _react.useContext)(_Context3.default),
      type = _useContext2.type,
      setType = _useContext2.setType;

  var _ref = appConfig || {},
      menu = _ref.menu;

  var authData = appConfig.auth.getData();
  var classes = useStyles();

  var _useContext3 = (0, _react.useContext)(_Context2.default),
      isDesktop = _useContext3.isDesktop,
      isDesktopOpen = _useContext3.isDesktopOpen,
      setDesktopOpen = _useContext3.setDesktopOpen,
      isMini = _useContext3.isMini,
      setMini = _useContext3.setMini,
      isAuthMenuOpen = _useContext3.isAuthMenuOpen,
      setAuthMenuOpen = _useContext3.setAuthMenuOpen,
      useMiniMode = _useContext3.useMiniMode;

  return /*#__PURE__*/_react.default.createElement(_Paper.default, {
    square: true,
    className: classes.paper,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 67,
      columnNumber: 5
    }
  }, isMini && authData.isAuthorised && /*#__PURE__*/_react.default.createElement("div", {
    className: classes.toolbar,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 69,
      columnNumber: 9
    }
  }), /*#__PURE__*/_react.default.createElement(_List.default, {
    className: (0, _clsx.default)(!authData.isAuthorised && classes.toolbar),
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 71,
      columnNumber: 7
    }
  }, /*#__PURE__*/_react.default.createElement(_ListItem.default, {
    className: classes.listItem,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 72,
      columnNumber: 9
    }
  }, authData.isAuthorised && /*#__PURE__*/_react.default.createElement(_react.default.Fragment, {
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 74,
      columnNumber: 13
    }
  }, authData.photoURL && /*#__PURE__*/_react.default.createElement(_ListItemAvatar.default, {
    onClick: function onClick() {
      setAuthMenuOpen(!isAuthMenuOpen);
    },
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 76,
      columnNumber: 17
    }
  }, /*#__PURE__*/_react.default.createElement(_Avatar.default, {
    src: authData.photoURL,
    alt: "user",
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 81,
      columnNumber: 19
    }
  })), !authData.photoURL && /*#__PURE__*/_react.default.createElement(_ListItemAvatar.default, {
    onClick: function onClick() {
      setAuthMenuOpen(!isAuthMenuOpen);
    },
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 85,
      columnNumber: 17
    }
  }, /*#__PURE__*/_react.default.createElement(_Avatar.default, {
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 90,
      columnNumber: 19
    }
  }, authData.displayName ? authData.displayName[0].toUpperCase() : /*#__PURE__*/_react.default.createElement(_Person.default, {
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 94,
      columnNumber: 25
    }
  })))), !isMini && /*#__PURE__*/_react.default.createElement(_ListItemSecondaryAction.default, {
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 102,
      columnNumber: 13
    }
  }, /*#__PURE__*/_react.default.createElement(_IconButton.default, {
    onClick: function onClick() {
      setType(type === 'light' ? 'dark' : 'light');
    },
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 103,
      columnNumber: 15
    }
  }, type === 'light' && /*#__PURE__*/_react.default.createElement(_Brightness.default, {
    classes: {
      root: classes.icon
    },
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 109,
      columnNumber: 19
    }
  }), type === 'dark' && /*#__PURE__*/_react.default.createElement(_BrightnessHigh.default, {
    classes: {
      root: classes.icon
    },
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 112,
      columnNumber: 19
    }
  })), isDesktop && /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, useMiniMode && /*#__PURE__*/_react.default.createElement(_IconButton.default, {
    onClick: function onClick() {
      setMini(true);
      setDesktopOpen(false);
    },
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 118,
      columnNumber: 21
    }
  }, /*#__PURE__*/_react.default.createElement(_ChromeReaderMode.default, {
    classes: {
      root: classes.icon
    },
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 124,
      columnNumber: 23
    }
  })), /*#__PURE__*/_react.default.createElement(_IconButton.default, {
    color: "inherit",
    onClick: function onClick() {
      setDesktopOpen(false);
    },
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 128,
      columnNumber: 19
    }
  }, theme.direction === 'rtl' && /*#__PURE__*/_react.default.createElement(_ChevronRight.default, {
    classes: {
      root: classes.icon
    },
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 135,
      columnNumber: 23
    }
  }), theme.direction !== 'rtl' && /*#__PURE__*/_react.default.createElement(_ChevronLeft.default, {
    classes: {
      root: classes.icon
    },
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 138,
      columnNumber: 23
    }
  })), "  "))), authData.isAuthorised && /*#__PURE__*/_react.default.createElement(_ListItem.default, {
    onClick: function onClick() {
      setAuthMenuOpen(!isAuthMenuOpen);
    },
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 146,
      columnNumber: 11
    }
  }, !isDesktopOpen && isDesktop && authData.photoURL && /*#__PURE__*/_react.default.createElement(_ListItemAvatar.default, {
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 152,
      columnNumber: 15
    }
  }, /*#__PURE__*/_react.default.createElement(_Avatar.default, {
    src: authData.photoURL,
    alt: "person",
    style: {
      marginLeft: -7,
      marginTop: 3
    },
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 153,
      columnNumber: 17
    }
  })), !isMini && /*#__PURE__*/_react.default.createElement(_ListItemText.default, {
    classes: {
      primary: classes.listItem,
      secondary: classes.listItem
    },
    style: {
      marginLeft: !isDesktopOpen && isDesktop && authData.photoURL ? 7 : undefined
    },
    primary: authData.displayName,
    secondary: authData.email,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 162,
      columnNumber: 15
    }
  }), isDesktopOpen && /*#__PURE__*/_react.default.createElement(_ListItemSecondaryAction.default, {
    onClick: function onClick() {
      setAuthMenuOpen(!isAuthMenuOpen);
    },
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 178,
      columnNumber: 15
    }
  }, /*#__PURE__*/_react.default.createElement(_IconButton.default, {
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 183,
      columnNumber: 17
    }
  }, isAuthMenuOpen && /*#__PURE__*/_react.default.createElement(_ArrowDropUp.default, {
    classes: {
      root: classes.icon
    },
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 185,
      columnNumber: 21
    }
  }), !isAuthMenuOpen && /*#__PURE__*/_react.default.createElement(_ArrowDropDown.default, {
    classes: {
      root: classes.icon
    },
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 188,
      columnNumber: 21
    }
  }))))));
};

var _default = MenuHeader;
exports.default = _default;
module.exports = exports.default;