"use strict";

exports.__esModule = true;
exports.default = void 0;

var _ArrowBack = _interopRequireDefault(require("@material-ui/icons/ArrowBack"));

var _Divider = _interopRequireDefault(require("@material-ui/core/Divider"));

var _IconButton = _interopRequireDefault(require("@material-ui/core/IconButton"));

var _KeyboardArrowRight = _interopRequireDefault(require("@material-ui/icons/KeyboardArrowRight"));

var _List = _interopRequireDefault(require("@material-ui/core/List"));

var _ListItem = _interopRequireDefault(require("@material-ui/core/ListItem"));

var _ListItemIcon = _interopRequireDefault(require("@material-ui/core/ListItemIcon"));

var _ListItemSecondaryAction = _interopRequireDefault(require("@material-ui/core/ListItemSecondaryAction"));

var _ListItemText = _interopRequireDefault(require("@material-ui/core/ListItemText"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireWildcard(require("react"));

var _this = void 0,
    _jsxFileName = "C:\\github\\os\\react-most-wanted\\packages\\material-ui-shell\\src\\containers\\SelectableMenuList\\SelectableMenuList.js";

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var SelectableMenuList = function SelectableMenuList(_ref) {
  var onIndexChange = _ref.onIndexChange,
      useMinified = _ref.useMinified,
      items = _ref.items,
      index = _ref.index;

  var _useState = (0, _react.useState)({}),
      state = _useState[0],
      setState = _useState[1];

  var handleNestedItemsClick = function handleNestedItemsClick(item) {
    if (item.nestedItems) {
      var previousItems = state.previousItems || [];
      var _items = item.nestedItems;
      var title = item.primaryText;
      previousItems.unshift(state.items || _items);
      setState(_extends(_extends({}, state), {}, {
        items: _items,
        previousItems,
        title,
        index: item.value
      }));
    } else {
      if (item.value || item.onClick) {
        setState(_extends(_extends({}, state), {}, {
          index: item.value
        }));
      }
    }
  };

  var handleBackClick = function handleBackClick() {
    var previousItems = state.previousItems || [];
    var items = previousItems[0] || undefined;
    previousItems.shift();
    setState(_extends(_extends({}, state), {}, {
      items,
      previousItems
    }));
  };

  var getNestedItems = function getNestedItems(hostItem, hostIndex) {
    if (hostItem.nestedItems !== undefined) {
      var _items2 = hostItem.nestedItems.filter(function (item) {
        return item.visible !== false;
      });

      if (_items2.length > 0) {
        return _items2.map(function (item, i) {
          return getItem(item, hostIndex.toString() + i.toString());
        });
      }
    }

    return null;
  };

  var getItem = function getItem(item, i) {
    var index = state.index;
    delete item.visible;

    if (item !== undefined) {
      if (item.subheader !== undefined) {
        return /*#__PURE__*/_react.default.createElement("div", {
          key: i,
          inset: item.inset,
          style: item.style,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 71,
            columnNumber: 11
          }
        }, item.subheader);
      } else if (item.divider !== undefined) {
        return /*#__PURE__*/_react.default.createElement(_Divider.default, {
          key: i,
          inset: item.inset,
          style: item.style,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 76,
            columnNumber: 16
          }
        });
      } else {
        return /*#__PURE__*/_react.default.createElement(_ListItem.default, {
          button: true,
          selected: index && index === item.value,
          key: i,
          onClick: function onClick(e) {
            onIndexChange(e, item.value);
            handleNestedItemsClick(item);

            if (item.onClick) {
              item.onClick();
            }
          },
          onMouseDown: function onMouseDown(e) {
            if (e.button === 1) {
              var win = window.open("" + item.value, '_blank');
              win.focus();
            }
          },
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 79,
            columnNumber: 11
          }
        }, item.leftIcon && /*#__PURE__*/_react.default.createElement(_ListItemIcon.default, {
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 98,
            columnNumber: 31
          }
        }, item.leftIcon), !useMinified && /*#__PURE__*/_react.default.createElement(_ListItemText.default, {
          primary: item.primaryText,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 100,
            columnNumber: 30
          }
        }), item.nestedItems && !useMinified && /*#__PURE__*/_react.default.createElement(_ListItemSecondaryAction.default, {
          onClick: function onClick() {
            handleNestedItemsClick(item);
          },
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 103,
            columnNumber: 15
          }
        }, /*#__PURE__*/_react.default.createElement(_IconButton.default, {
          style: {
            marginRight: useMinified ? 150 : undefined
          },
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 108,
            columnNumber: 17
          }
        }, /*#__PURE__*/_react.default.createElement(_KeyboardArrowRight.default, {
          color: 'action',
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 111,
            columnNumber: 19
          }
        }))));
      }
    }

    return null;
  };

  var list = state.previousItems && state.previousItems.length > 0 ? state.items : items;
  return /*#__PURE__*/_react.default.createElement(_List.default, {
    value: index,
    onChange: onIndexChange,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 127,
      columnNumber: 5
    }
  }, state.items && state.previousItems && state.previousItems.length > 0 && /*#__PURE__*/_react.default.createElement("div", {
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 129,
      columnNumber: 9
    }
  }, /*#__PURE__*/_react.default.createElement(_ListItem.default, {
    button: true,
    onClick: function onClick() {
      handleBackClick();
    },
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 130,
      columnNumber: 11
    }
  }, /*#__PURE__*/_react.default.createElement(_ListItemIcon.default, {
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 136,
      columnNumber: 13
    }
  }, /*#__PURE__*/_react.default.createElement(_ArrowBack.default, {
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 137,
      columnNumber: 15
    }
  })), /*#__PURE__*/_react.default.createElement(_ListItemText.default, {
    primary: state.title,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 139,
      columnNumber: 13
    }
  })), /*#__PURE__*/_react.default.createElement(_Divider.default, {
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 141,
      columnNumber: 11
    }
  })), list.filter(function (item) {
    return item.visible !== false;
  }).map(function (item, i) {
    return getItem(item, i);
  }));
};

SelectableMenuList.propTypes = process.env.NODE_ENV !== "production" ? {
  items: _propTypes.default.array.isRequired,
  onIndexChange: _propTypes.default.func.isRequired,
  index: _propTypes.default.string.isRequired
} : {};
var _default = SelectableMenuList;
exports.default = _default;
module.exports = exports.default;